Foreman - Bug #6914

puppet class with numeric nhame can neither be edited nor deleted.
08/04/2014 10:14 AM - Dominic Cleal

Status: Closed

Priority: Normal

Assignee:

Category: Web Interface

Target version: 1.7.0

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1126473 Red Hat JIRA:

Pull request:

Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1126473
Description of problem:

Puppet class which contains names with numeric value can neither be edited nor deleted.
tail -f /var/log/foreman/production.log

Processing by PuppetclassesController#destroy as HTML

Parameters: {"authenticity_token"=>"LS/dL1pfhWgLRML7GMd72iCb8bN/ZAk1UaykFrtRIPY=", "id"=>"02197821"}

Rendered common/404.html.erb within layouts/application (2.7ms)
Rendered layouts/base.html.erb (3.2ms)
Completed 404 Not Found in 47ms (Views: 12.4ms | ActiveRecord: 3.9ms)

Version-Release number of selected component (if applicable):
sat6-GA-snap3

How reproducible:
always

Steps to Reproduce:
1.
2.
3.

Actual results:
puppet classes created with numeric values can neither be edited nor deleted.

Expected results:
puppet classes once created should be allowed to be edited and deleted.

Additional info:

Related issues:

Related to Foreman - Bug #6890: Puppet environment cannot be edited when name... Closed 08/01/2014
Related to Foreman - Feature #4386: implement gem friendly_id to simply find ... Closed 02/19/2014
Has duplicate Foreman - Bug #7414: Can't delete class if contains special cha... Duplicate 09/11/2014
History

#1 - 08/04/2014 10:14 AM - Dominic Cleal

- Related to Bug #6890: Puppet environment cannot be edited when name is only numeric added

#2 - 08/04/2014 10:14 AM - Dominic Cleal

- Category set to Web Interface
https://bugzilla.redhat.com/show_bug.cgi?id=1126473

#3 - 08/25/2014 04:11 PM - b sh

I would like to try and fix this (just for fun).

From the log, | have noticed a strange behavior.
If the name contains only numerical characters, ActiveRecord runs a query that looks for an id that matches.
Otherwise, it goes over the records' name attribute and compares.

I will try to figure out a nice way to fix this.
BR.

The log:

Started GET "/puppetclasses/123bla/edit" for 172.17.42.1 at 2014-08-25 19:37:46 +0000

Processing by PuppetclassesController#edit as HTML

Parameters: {"id"=>"123bla"}

Puppetclass Load (0.3ms) SELECT "puppetclasses".* FROM "puppetclasses" WHERE "puppetclasses"."name" = '123bla’ ORDER BY
puppetclasses.name LIMIT 1

Started GET "/puppetclasses/123/edit" for 172.17.42.1 at 2014-08-25 19:37:53 +0000

Processing by PuppetclassesController#edit as HTML

Parameters: {"id"=>"123"}

Puppetclass Load (0.1ms) SELECT "puppetclasses".* FROM "puppetclasses" WHERE "puppetclasses"."id" = ? ORDER BY puppetclasses.name
LIMIT 1 "id", "123"

not found: Couldn't find Puppetclass with id=123

#4 - 08/26/2014 07:04 AM - b sh

OK, | guess this is the reason for that behavior.

@puppetclass = (params[:id] =~ NA\d+\Z/) ? pc.find(params[:id]) : pc.find_by name(paramsl[:id])

If the “params[:id]" is a number then we use “find". Otherwise, we use “find_by_name’.
We probably should change this logic, to fix this bug.

BR.

#5 - 08/31/2014 06:51 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Target version set to 1.7.4

- Pull request https://github.com/theforeman/foreman/pull/1723 added
- Pull request deleted ()

#6 - 09/10/2014 07:21 AM - Anonymous

- Target version changed from 1.7.4 to 1.7.3

#7 - 09/11/2014 11:53 AM - Dominic Cleal

- Has duplicate Bug #7414: Can't delete class if contains special characters added

#8 - 09/21/2014 03:52 AM - Ohad Levy

- Status changed from Ready For Testing to New

- Target version deleted (1.7.3)

- Pull request added

- Pull request deleted (https://github.com/theforeman/foreman/pull/1723)

upstream pull request has been closed.

#9 - 11/10/2014 03:27 AM - Dominic Cleal
- Status changed from New to Closed
- Target version setto 1.7.2

- translation missing: en.field_release set to 21

Fixed via #4386.
https://projects.theforeman.org/projects/foreman/wiki/%22id%22_%22123%22
https://projects.theforeman.org/issues/4386

#10 - 11/10/2014 03:28 AM - Dominic Cleal
- Related to Feature #4386: implement gem friendly_id to simply find by id, name, label, etc added
